<div id="@budget_tree_id@" style="height: 600px; overflow: hidden; -webkit-user-select: none; -moz-user-select: none; -khtml-user-select: none; -ms-user-select: none;">

<!-- define the icons for the various sub-types of projects in the tree -->
<style type="text/css">
    .icon-budget-item      { background-image: url("/intranet/images/navbar_default/coins.png") !important; } 
    .icon-timesheet-cost   { background-image: url("/intranet/images/navbar_default/clock.png") !important; } 
    .icon-provider-bill    { background-image: url("/intranet/images/navbar_default/lorry.png") !important; } 
    .icon-purchase-order   { background-image: url("/intranet/images/navbar_default/lorry_go.png") !important; } 
</style>

<script type='text/javascript' <if @::__csp_nonce@ not nil>nonce="@::__csp_nonce;literal@"</if>>

Ext.Loader.setConfig({disableCaching: false});			// Disable the ?_dc=123456789 parameter from loader
Ext.Loader.setPath('PO', '/sencha-core');
Ext.Loader.setPath('PO.budget', '/intranet-budget/js');

Ext.require([
    'Ext.data.*',
    'Ext.grid.*',
    'Ext.tree.*',
    'Ext.state.*',
    'PO.Utilities',
    'PO.budget.BudgetTreeItem',			// Main model for tree. This is _not_ BudgetItem, but a mix of BI and Costs
    'PO.budget.BudgetTreeItemStore',		// Main tree store
    'PO.class.PreferenceStateProvider',		// Stores open/close status of BIs
    'PO.controller.ResizeController',		// Handles "Maximize" button etc.
    'PO.controller.StoreLoadCoordinator',	// Waits until all important stores are loaded...
    'PO.model.user.SenchaPreference',		// Stores open/close status of BIs
    'PO.model.user.User',			// A user, required for Combo with list of users for match selection
    'PO.store.CategoryStore',			// Generic category store
    'PO.store.group.GroupStore',
    'PO.store.finance.CostStatusStore',		// Store for "Intranet Cost Status"
    'PO.store.finance.CostTypeStore',		// Store for "Intranet Cost Status"
    'PO.store.finance.ExpenseItemTypeStore',	// Store for ...
    'PO.store.finance.BudgetItemStatusStore',	// Store for ...
    'PO.store.finance.BudgetItemTypeStore',	// Store for ...
    'PO.store.finance.BudgetItemTreeStore',	// Store for ...
    'PO.store.finance.MaterialTypeStore',	// Store for ...
    'PO.store.timesheet.TaskTreeStore',		// Tree store for the list of activities in this project for match selection
    'PO.store.user.SenchaPreferenceStore',	// Stores open/close status of BIs
    'PO.store.user.UserStore',			// Stores users for user match selection
    'PO.view.field.POComboTree',		// ]po[ custom bombo to show tree of activities
    'PO.view.field.POObjectMembers',		// ]po[ custom field to show business object members
    'PO.view.ObjectMemberPanel',		// Panel for POObjectMembers field
    'PO.view.menu.HelpMenu',			// Help Menu
    'PO.view.menu.ConfigMenu'			// Configuration Menu
]);



/**
 * Implement a filtered tree functionality
 */
var initBody = Ext.data.NodeInterface.getPrototypeBody();
Ext.data.NodeInterface.addStatics({getPrototypeBody : function() {
    return Ext.apply(
        initBody, {
            /**
             * Recursively copy those leaf elements with filterFn(node) = true
             */
            copyFilterBy: function(newId, deep, filterFn, scope) {
                var me = this;
                var len = me.childNodes ? me.childNodes.length : 0;
                var result = me.createNode(me.copy(newId, false));
                if (deep) {
                    for (var i = 0; i < len; i++) {
                        // Only filter in leaf elements
                        var child = me.childNodes[i];
                        var childLen = child.childNodes ? child.childNodes.length : 0;
                        if (childLen == 0 && !!filterFn) {
                            if (filterFn.call(scope || me, child)) {
                                result.appendChild(child.copyFilterBy(null, true, filterFn, scope));
                            }
                        } else {
                            result.appendChild(child.copyFilterBy(null, true, filterFn, scope));
                        }
                    }
                }
                return result;
            }
    
        })
}});


Ext.define("PO.data.TreeStore", {
    override: "Ext.data.TreeStore",

    /**
     * Simple debug write-out of a NodeInterface
     */
    treeDebug: function(root) {
        var me = this;
        // console.log('PO.data.TreeStore.treeDebug: Starting');

        root.cascadeBy(function(node) {
            // console.log(node);
            var id = node.get('id');
            var name = node.get('name');
            var depth = node.getDepth();
            var spaces = "";
            for (var i = 0; i < depth; i++) spaces = spaces + '    ';
            console.log(id+"\t"+spaces+name);
        });
        
        // console.log('PO.data.TreeStore.treeDebug: Starting');
    },

    
    /**
     * Filters the current tree by a function filterFn
     * if the function returns true the node will be in the filtered tree
     * a filtered tree has also a flat structure without folders
     */
    filterBy: function(filterFn, scope) {
        var me    = this,
            nodes = [],
            root  = me.getRootNode(),
            tmp;

        console.log('filterBy: original root of budget tree');
        me.treeDebug(root);

        // the snapshot holds a copy of the current unfiltered tree
        me.snapshot = me.snapshot || root.copyFilterBy(null, true);
        console.log('filterBy: snapshot');
        me.treeDebug(me.snapshot);        

        // tmp = me.snapshot.copyFilterBy(null, true, filterFn, scope);
        tmp = me.snapshot.copyFilterBy(null, true, filterFn, scope);
        console.log('filterBy: tmp');
        me.treeDebug(tmp);

        // Move the filtered tree under the root
        var firstChild = tmp.firstChild;
        delete tmp;
        root.removeAll();
        root.appendChild(firstChild);
        return me;        
    },
    
    /**
     * Clears all filters a shows the unfiltered tree
     */
    clearFilter: function() {
        var me = this;
        if (me.isFiltered()) {
            me.setRootNode(me.snapshot);
            delete me.snapshot;
        }        
        return me;
    },

    /**
     * Returns true if the tree is filtered
     */
    isFiltered: function() {
        return !!this.snapshot;
    }
});


// Scrap this. A filter on columns is available in one
// of the ExtJS demos.
Ext.define('PO.menu.ColumnFilterMenu', {
    extend: 'Ext.menu.Menu',
    hideOnClick : true,
    pickerId : null,

    initComponent : function(){
        var me = this,
            cfg = Ext.apply({}, me.initialConfig);

        // Ensure we don't get duplicate listeners
        delete cfg.listeners;
        Ext.apply(me, {
            plain: true,
            showSeparator: false,
            items: [
                {
                    xtype: 'menucheckitem',
                    text: 'Test Checker'
                }, {
                    cls: Ext.baseCSSPrefix + 'menu-color-item',
                    id: me.pickerId,
                    xtype: 'button'
                }
            ]
        });

        me.callParent(arguments);
        me.picker = me.down('button');
        me.relayEvents(me.picker, ['select']);

        if (me.hideOnClick) {
            me.on('select', me.hidePickerOnSelect, me);
        }

        // Setup the menu per column before showing it
        me.on('beforeshow', me.onBeforeShow, me);
    },


    /**
     * Setup the menu per column before showing it
     */
    onBeforeShow: function(columnFilterMenu, scope) {
        var me = this;

        var menu = me.parentMenu;            // of type Ext.menu.Menu
        var activeHeader = menu.activeHeader; // of type Ext.grid.column.Column
        var tablePanel = this.up('tablepanel');
        var treeStore = tablePanel.store;
        var root = treeStore.getRootNode();
        var dataIndex = activeHeader.dataIndex;
        var renderer = activeHeader.renderer;
        
        // Cleanup old values and add the check-all
        me.removeAll(true);
        me.add({
            xtype: 'menucheckitem',
            text: 'Enable/Disable All',
            checked: true,
            handler: me.onToggleEnableAll
        });
        me.add({xtype: 'menuseparator'});

        var renderedValues = {};
        var valuesOfRendered = {};
        root.cascadeBy(function(model) {
            var value = ''+model.get(dataIndex);
            var renderedValue = ''+value;
            if (renderer) {
                renderedValue = renderer.call(me, value);
            }
            renderedValues[value] = renderedValue;
            valuesOfRendered[renderedValue] = value;
        })
        var orderedRenderedValues = Object.keys(valuesOfRendered).sort();
        console.log(orderedRenderedValues);

        orderedRenderedValues.forEach(function(rendVal) {
            if (rendVal == "") rendVal = "(empty)";
            me.add({
                xtype: 'menucheckitem',
                text: rendVal,
                checked: true
            });

        });
        
        me.add ({
            xtype: 'button',
            width: 60,
            text: "Apply Filter",
            columnCheckMenu: this,
            handler: function() {
                var me = this;
                var colCheckMenu = this.columnCheckMenu;
                colCheckMenu.onButtonApply(me);
            }
        });
        
    },


    /**
     * User pressed the "Apply Filter" button.
     * So we now want to create + apply a filter
     * to the store.
     */
    onButtonApply: function(button) {
        var me = this;                                         // ColumnFilterMenu
        console.log('PO.menu.ColumnFilterMenu.onButtonApply: Starting');
        console.log(me);
        console.log(button);

        var menu = me.parentMenu;            // of type Ext.menu.Menu
        var activeHeader = menu.activeHeader; // of type Ext.grid.column.Column
        var tablePanel = this.up('tablepanel');
        var treeStore = tablePanel.store;
        var root = treeStore.getRootNode();
        var dataIndex = activeHeader.dataIndex;
        var renderer = activeHeader.renderer;

        treeStore.filterBy(function(model, scope) {

            return false;
            
        });
        console.log('PO.menu.ColumnFilterMenu.onButtonApply: Finished');
    },

    
    hidePickerOnSelect: function() {
        Ext.menu.Manager.hideAll();
    },

    /**
     * Handle the check/uncheck all click
     */
    onToggleEnableAll: function(menuItem, event) {
        console.log('PO.menu.ColumnFilterMenu.onToggleEnableAll: Starting');
        var checked = menuItem.checked;
        var columnFilterMenu = menuItem.ownerCt;
        var menuItemsCollection = columnFilterMenu.items;

        menuItemsCollection.each(function(item) {
            if ('checked' in item)
                item.setChecked(checked);   
        });
        
        console.log('PO.menu.ColumnFilterMenu.onToggleEnableAll: Finished');
    }
});



/**
 * Add a "Filter" menu to the column headers in order to 
 * restrict the set of values shown for colums with a finite set of values.
 */
Ext.define('PO.grid.header.Container', {
    override: 'Ext.grid.header.Container',

    getMenuItems: function() {
        var me = this,
            menuItems = [],
            hideableColumns = me.enableColumnHide ? me.getColumnMenu(me) : null;
        
        if (me.sortable) {
            menuItems = [{
                itemId: 'ascItem',
                text: me.sortAscText,
                cls: me.menuSortAscCls,
                handler: me.onSortAscClick,
                scope: me
            },{
                itemId: 'descItem',
                text: me.sortDescText,
                cls: me.menuSortDescCls,
                handler: me.onSortDescClick,
                scope: me
            }];
            menuItems.push('-');
        }

        var filterMenu = Ext.create('PO.menu.ColumnFilterMenu', {});
        menuItems.push({
            itemId: 'filterItem',
            text: "Filter Column",
            cls: me.menuColsIcon,
            hideOnClick: false,
            menu: filterMenu,
            scope: me
        });

        if (hideableColumns && hideableColumns.length) {
            if (menuItems.length > 0) { menuItems.push('-'); }
            menuItems.push({
                itemId: 'columnItem',
                text: me.columnsText,
                cls: me.menuColsIcon,
                menu: hideableColumns,
                hideOnClick: false
            });
        }
        return menuItems;
    }
});



// Launch the actual application
// This happens after all required stores have been loaded (see below)
function launchBudgetTreePanel() {
    var budgetItemTreeStore = Ext.StoreManager.get('budgetTreeItemStore');
    var budgetItemStatusStore = Ext.StoreManager.get('budgetItemStatusStore');
    var budgetItemTypeStore = Ext.StoreManager.get('budgetItemTypeStore');
    var costStatusStore = Ext.StoreManager.get('costStatusStore');
    var costTypeStore = Ext.StoreManager.get('costTypeStore');
    var classifiedCostTypeStore = Ext.StoreManager.get('classifiedCostTypeStore');
    var categoryStore = Ext.StoreManager.get('categoryStore');
    var expenseItemTypeStore = Ext.StoreManager.get('expenseItemTypeStore');
    var materialTypeStore = Ext.StoreManager.get('materialTypeStore');
    var taskTreeStore = Ext.StoreManager.get('taskTreeStore');
    var userStore = Ext.StoreManager.get('userStore', {storeId: 'userStore'});
    var cat = categoryStore;

    var budgetManagerStore = Ext.StoreManager.get('budgetManagerStore');
    var budgetGroupStore = Ext.StoreManager.get('budgetGroupStore');
    
    // Define type and status stores per object type
    var objectTypeStoreHash = {
        "im_budget_item": budgetItemTypeStore,
        "im_cost": costTypeStore,
        "im_invoice": costTypeStore
    };
    var objectStatusStoreHash = {
        "im_budget_item": budgetItemStatusStore,
        "im_cost": costStatusStore,
        "im_invoice": costStatusStore
    };


    var gifPath = "/intranet/images/navbar_default/";

    // Deal with state
    var stateProvider = Ext.create('PO.class.PreferenceStateProvider', {
        debug: getDebug('stateProvider'),
        url: window.location.pathname + window.location.search
    });
    Ext.state.Manager.setProvider(stateProvider);
    var senchaPreferenceStore = Ext.StoreManager.get('senchaPreferenceStore');

    /* ***********************************************************************
     * Help Menu
     *********************************************************************** */
    var helpMenuBudget = Ext.create('PO.view.menu.HelpMenu', {
        id: 'helpMenuBudget',
        debug: getDebug('helpMenuBudget'),
        style: {overflow: 'visible'},						// For the Combo popup
        store: Ext.create('Ext.data.Store', { fields: ['text', 'url'], data: [
            {text: 'Budget Management - Tutorial', url: 'https://www.project-open.net/en/process-fi-budget-management'},
            {text: 'Budget Management - Package Reference', url: 'https://www.project-open.net/en/package-intranet-budget'}
        ]})
    });


    /* ***********************************************************************
     * Config Menu
     *********************************************************************** */
    var configMenuBudget = Ext.create('PO.view.menu.ConfigMenu', {
        debug: getDebug('configMenuBudget'),
        id: 'configMenuBudget',
        senchaPreferenceStore: senchaPreferenceStore,
        items: [
        {
            id: 'config_menu_show_cross_project_overassignments',
            key: 'show_project_cross_project_overassignments', 
            text: 'Show Cross-Project Overassignments', 
            checked: true
        }, {
            id: 'config_menu_show_project_dependencies',
            key: 'show_project_dependencies', 
            text: 'Show Project Dependencies', 
            checked: true
        },  {
            id: 'config_menu_show_project_assigned_resources',
            key: 'show_project_assigned_resources', 
            text: 'Show Project Assigned Resources', 
            checked: true
        },  {
            id: 'config_menu_show_percent_done_bar',
            key: 'show_percent_done_bar', 
            text: 'Show "Done %" Gantt Bars', 
            checked: false
        },  {
            id: 'config_menu_show_logged_hours_bar',
            key: 'show_logged_hours_bar', 
            text: 'Show "Logged Hours %" on Gantt Bars', 
            checked: true
        },  {
            id: 'config_menu_show_project_findocs',
            key: 'show_project_findocs', 
            text: 'Show Project Financial Documents', 
            checked: true
        }]
    });

    // Enable row editing - there is a bug currently...
    var rowEditing = Ext.create('Ext.grid.plugin.RowEditing', {
        clicksToMoveEditor:		2,
        autoCancel:			false
    });



    // Enable in-line cell editing.
    var cellEditing = Ext.create('Ext.grid.plugin.CellEditing', {
        debug: true,
        clicksToEdit: 1,
        listeners: {
            // Veto editing for certain columns and rows
            beforeedit: function(editor, context, eOpts) {
                var me = this;
                if (me.debug) console.log('PO.budget.BudgetTreePanelCellEditing.cellediting.beforeedit: Starting');

                var model = context.record;
                var field = context.field;
                var object_type = context.record.get('object_type');
                if ("im_budget_item" !== object_type) {
                    // if (me.debug) console.log('PO.budget.BudgetTreePanelCellEditing.cellediting.beforeedit: Rejecting to edit object_type='+object_type);
                    PO.Utilities.reportMessage('Unable to edit', 'You cannnot edit the members of a cost item here.');
                    // alert('PO.budget.BudgetTreePanelCellEditing.cellediting.beforeedit: Rejecting to edit object_type='+object_type);
                    return false;
                }

                if (me.debug) console.log('PO.budget.BudgetTreePanelCellEditing.cellediting.beforeedit: Finished');
                return true;
            },
            // Invalid values from the editor may cause "save" operations to fail.
            validateedit: function(editor, context, eOpts) {
                var me = this;
                if (me.debug) console.log('PO.budget.BudgetTreePanelCellEditing.cellediting.validateedit');

                var field = context.field;
                var value = context.value;
                var model = context.record;

                // Veto any null values.
                if (value == null) { 
                    // alert('validateEdit: Rejecting null value for field='+field);
                    return false; 
                }

                switch (field) {
                    case "name":
                    // Name is used to display (and edit) the BI in the Tree.
                    // However, in the database we need to update the value of budget_item_name
                    model.set('budget_item_name', value);
                    break;
                }

                return true;
            },

            // Commit changes
            edit: function(editor, context, eOpts) {
                var me = this;
                if (me.debug) console.log('PO.budget.BudgetTreePanelCellEditing.cellediting.edit: Starting');
                
                budgetItemTreeStore.sync({
                    success: function(batch, options) {
                        var message = batch.proxy.reader.jsonData.message;
                        if (me.debug) console.log('PO.budget.BudgetTreePanelCellEditing.cellediting.edit: '+message);
                        context.record.commit();
                    },
                    failure: function(batch, options) {
                        var message = batch.proxy.reader.jsonData.message;
                        PO.Utilities.reportError('Error editing budget item', message);
                    }
                });

                if (me.debug) console.log('PO.budget.BudgetTreePanelCellEditing.cellediting.edit: Finished');
            }
        }
    });

    var budgetTreePanel = Ext.create('Ext.tree.Panel', {
        id:				'budgetTreePanel',
        title:				'@diagram_title@',
        width:				@diagram_width@,
        height:				@diagram_height@,
        renderTo:			'@budget_tree_id@',
        useArrows:			true,
        rootVisible:			false,
        store:				budgetItemTreeStore,
        multiSelect:			true,
        singleExpand:			false,
        debug:				true,
        resizable:			true,				// Add handles to the panel, so the user can change size

        // Enable in-line row editing.
        plugins:			[cellEditing],

        // Enabled drag-and-drop for the tree. Yes, that's all...
        viewConfig: {
            plugins: {
                ptype: 'treeviewdragdrop',
                containerScroll: true
            }
        },

        // the 'columns' property is now 'headers'
        columns: [
            {text: 'ID', coltype: 'none', flex: 1, dataIndex: 'id', sortable: true, editor: false },
            {text: 'Name', xtype: 'treecolumn', coltype: 'all', flex: 4, sortable: true, dataIndex: 'name', 
             getEditor: function(record, defaultField) {
                 if ("im_budget_item" !== record.get('object_type')) { PO.Utilities.reportMessage('Unable to edit', 'You cannnot edit a cost item here.'); return false; }
                 return Ext.create('Ext.grid.CellEditor', {field: Ext.create('Ext.form.field.Text', {allowBlank: false})}); // Text editor for budget item name
             }
            },
            {text: 'Type', coltype: 'actuals', flex: 1, dataIndex: 'object_type_id', sortable: true, 
             renderer: function(category_id) {
                 if (49100 == category_id) return "Budget Item";
                 return cat.cat(category_id);
             },
             getEditor: function(record, defaultField) {
                 // PO.Utilities.reportMessage('Unable to edit', 'You cannnot edit an object type.');
                 // return false;
                 var objectType = record.get('object_type');
                 var store = objectTypeStoreHash[objectType];		// type store for object type
                 if (!store) alert('BudgetTreePanel.object_type_id.getEditor: Unknown object_type='+object_type);
                 return Ext.create('Ext.grid.CellEditor', {field: Ext.create('Ext.form.field.ComboBox', {queryMode: 'local', store: store, displayField: 'category', valueField: 'category_id', matchFieldWidth: false})});
             }
            },
            {text: 'Status', coltype: 'none', flex: 1, dataIndex: 'object_status_id', sortable: true, editor: false,
             renderer: function(category_id) { return cat.cat(category_id); },
            },

            {text: 'Managers', coltype: 'all', flex: 1, dataIndex: 'members', sortable: true, editor: false,
             memberStore: budgetManagerStore,
             editor: Ext.create('PO.view.field.POObjectMembers', {
                 gridPanelId: 'budgetTreePanel',
                 debug: true,
                 memberStore: budgetManagerStore,
                 groupStore: budgetGroupStore
             }),
             renderer: function(value, context, model, columnX, columnY, nodeStore, treeView, e) {
                 var gridColumn = context.column;
                 var editor = gridColumn.getEditor();
                 var isLeaf = (0 == model.childNodes.length);
                 var result = PO.view.field.POObjectMembers.formatMembers(editor, value);
                 if (isLeaf) { return result; } else { return "<b>"+result+"</b>"; }
             }
            },

            {text: 'Owner', coltype: 'none', flex: 1, dataIndex: 'budget_item_owner_id', sortable: true, editor: {allowBlank: true}},
            {text: 'Budget Value', coltype: 'actuals', hideable: false, width:50, flex: 1, align:'right', dataIndex: 'budget_item_max_value', sortable: true, editor: {xtype: 'numberfield', minValue: 0}},
            {text: 'Remaining Value', coltype: 'actuals', width:50, flex: 1, align:'right', sortable: true, editor: false, renderer: function(value, metaData, record, rowIndex, colIndex, store) {
                var budgetValue = record.get('budget_item_max_value');
                if ("" == budgetValue) return "";		// Don't show any value if there was no budget value set
                var actualValue = record.get('cost_type_0');
                if ("" == budgetValue || !budgetValue) budgetValue = 0.0;
                if ("" == actualValue || !actualValue) actualValue = 0.0;
                var result = budgetValue - actualValue;
                if (result < 0) result = "<font color=red><b>"+result+"</b></font>";
                return result;
            }},

            {text: 'Alarm Value', coltype: 'actuals', width:50, flex: 1, align:'right', dataIndex: 'budget_item_alarm_value', sortable: true, editor: {xtype: 'numberfield', minValue: 0}},
            {text: 'Actual Cost', coltype: 'actuals', flex: 1, align:'right', dataIndex: 'cost_type_0', sortable: true, editor: false},
            
            // "Match" columns - for setting up budget classification
            {text: 'Cost Type Match', coltype: 'config', flex: 1, dataIndex: 'match_cost_type_id', sortable: true,
             renderer: function(category_id) { return cat.cat(category_id); },
             getEditor: function(record, defaultField) {
                 var objectType = record.get('object_type'); if ("im_budget_item" !== objectType) return false;
                 return Ext.create('Ext.grid.CellEditor', {field: Ext.create('Ext.form.field.ComboBox', {queryMode: 'local', store: classifiedCostTypeStore, displayField: 'category', valueField: 'category_id', matchFieldWidth: false})});
             }
            },

            {text: 'Task Match', coltype: 'config', flex: 1, dataIndex: 'match_task_id', sortable: true,
             renderer: function(task_id) { var taskModel = taskTreeStore.getById(task_id); if (!taskModel) return ""; return taskModel.get('project_name'); },
             getEditor: function(record, defaultField) {
                 var objectType = record.get('object_type'); if ("im_budget_item" !== objectType) return false;
                 return Ext.create('Ext.grid.CellEditor', {
                     field: Ext.create('PO.view.field.POComboTree', {
                         queryMode: 'local', store: taskTreeStore, displayField: 'project_name', valueField: 'id'
                     })
                 });
             }
            },

            {text: 'User Match', coltype: 'config', flex: 1, dataIndex: 'match_user_id', sortable: true,
             renderer: function(uid) { if (!uid) return ""; var model = userStore.getById(uid); return model.get('name'); },
             getEditor: function(record) {
                 var objectType = record.get('object_type'); 
                 if ("im_budget_item" !== objectType) return false;
                 return Ext.create('Ext.grid.CellEditor', {
                     field: Ext.create('Ext.form.field.ComboBox', {
                         queryMode: 'local', 
                         store: userStore, 
                         displayField: 'name', 
                         valueField: 'id', 
                         matchFieldWidth: false
                     })
                 });
             }
            },

            {text: 'Material Type Match', coltype: 'config', flex: 1, dataIndex: 'match_material_type_id', sortable: true,
             renderer: function(category_id) { return cat.cat(category_id); },
             getEditor: function(record, defaultField) {
                 var objectType = record.get('object_type'); if ("im_budget_item" !== objectType) return false;
                 return Ext.create('Ext.grid.CellEditor', {field: Ext.create('Ext.form.field.ComboBox', {queryMode: 'local', store: materialTypeStore, displayField: 'category', valueField: 'category_id', matchFieldWidth: false})});
             }

             // tpl : '<tpl for="."><div class="x-boundlist-item">{category_translated}&nbsp;</div></tpl>'

            },

            {text: 'Expense Item Type Match', coltype: 'none', flex: 1, dataIndex: 'match_expense_type_id', sortable: true,
             renderer: function(category_id) { return cat.cat(category_id); },
             getEditor: function(record, defaultField) {
                 var objectType = record.get('object_type'); if ("im_budget_item" !== objectType) return false;
                 return Ext.create('Ext.grid.CellEditor', {field: Ext.create('Ext.form.field.ComboBox', {queryMode: 'local', store: expenseItemTypeStore, displayField: 'category', valueField: 'category_id', forceSelection: true, matchFieldWidth: false})});
             }
            },

            @cost_type_actuals_columns;noquote@
            {text: 'Description', coltype: 'none', flex: 1, dataIndex: 'description', sortable: true},
            {text: 'Note', coltype: 'none', flex: 1, dataIndex: 'note', sortable: true},
        ],

        ttt: [
//            {text: 'Amount', coltype: 'actuals', flex: 1, dataIndex: 'amount', sortable: true, editor: {xtype: 'numberfield', minValue: 0}},
            {text: 'Nr', coltype: 'all', flex: 1, dataIndex: 'nr', sortable: true, editor: {allowBlank: true}},
            {text: 'Object Type', coltype: 'none', flex: 1, dataIndex: 'object_type', sortable: true},
            {text: 'Type', coltype: 'none', flex: 1, dataIndex: 'budget_item_type_id', sortable: true},
            {text: 'Project', coltype: 'none', flex: 1, dataIndex: 'budget_item_project_id', sortable: true},
            {text: 'Sort Order', coltype: 'all', flex: 1, dataIndex: 'sort_order', sortable: true, editor: {xtype: 'numberfield', minValue: 0}},
            {text: 'Level', coltype: 'all', flex: 1, dataIndex: 'level', sortable: true},
        ],

        listeners: {
            'selectionchange': function(view, records) { }
        },

        // Toolbar for adding and deleting budgets
        tbar: [
            { text: 'Maximize', icon: gifPath+'arrow_out.png', tooltip: 'Maximize the editor &nbsp;', id: 'buttonMaximizeBudget'}, 
            { text: 'Restore', icon: gifPath+'arrow_in.png', tooltip: 'Restore default editor size &nbsp;', id: 'buttonMinimizeBudget', hidden: true},
            { xtype: 'tbseparator' }, 
            { text: 'Add', icon: gifPath+'add.png', tooltip: 'Add a new task', id: 'buttonAddBudget'}, 
            { text: 'Delete', icon: gifPath+'delete.png', tooltip: 'Delete a task', id: 'buttonDeleteBudget'}, 
            '->', 
            { text: 'Reclassify', icon: gifPath+'arrow_refresh.png', tooltip: 'Re-Classify cost items', handler: function() { budgetTreePanel.reclassify(); } },
            '->', 
            {   // A radio button group to select the label
                xtype: 'fieldcontainer', fieldLabel: 'View', labelWidth: 20, defaultType: 'radiofield', layout: 'hbox',
                defaults: { flex: 2, minWidth: 100 },
                items: [
                    { boxLabel: 'Plan vs. Actual', name: 'size', inputValue: 'm', id: 'buttonViewPlanVsActual1', checked: true,
                      handler: function(radio,value) { if (!value) return; budgetTreePanel.switchColumns('actuals');  }
                    }, 
                    { boxLabel: 'Match Settings', name: 'size', inputValue: 'l', id: 'buttonViewMatchSettings1',
                      handler: function(radio, value) { if (!value) return; budgetTreePanel.switchColumns('config'); }
                    }
                ]
            },
            '->', 
            { text: 'Configuration', icon: gifPath+'wrench.png', menu: configMenuBudget}, 
            { text: 'Help', icon: gifPath+'help.png', menu: helpMenuBudget}
            //,{ text: 'This is Beta!', icon: gifPath+'bug.png', menu: alphaMenu}
        ],

        listeners: {
            // Reset the dirty status to not dirty.
            render: function(a,b,c) {
                // budgetItemTreeStore.getRootNode().cascadeBy(function(model) { if (model.dirty) model.commit(); });
            }
        },

        /**
         * Switch between the three different "views" {all|nonce|conf|actuals|time}
         * that determine which columns to be shown.
         */
        switchColumns: function(setColtype) {
            var me = this;
            if (me.debug) console.log('PO.budget.BudgetTreePanel.switchColumns('+coltype+'): Starting');

            me.suspendLayout = true;
            me.suspendEvents();
            
            // Hide all columns except for coltype=all
            for (var i = me.columns.length-1; i >= 0; i--) { 
                if (me.debug) console.log('PO.budget.BudgetTreePanel.switchColumns: i='+i);
                var coltype = me.columns[i].coltype;
                var visible = ("all" == coltype);
                if (coltype == setColtype) visible = true;
                var col = me.columns[i];
                var isVisible = col.isVisible();

                if (visible != isVisible) {
                    col.setVisible(visible);
                }
            }

            me.resumeEvents();
            me.suspendLayout = false;
            me.doLayout();

            if (me.debug) console.log('PO.budget.BudgetTreePanel.switchColumns: Finished');
        },
        
        /**
         * Re-Classify all cost items in the project
         */
        reclassify: function() {
            var me = this;
            if (me.debug) console.log('PO.budget.BudgetTreePanel.reclassify: Starting');
            Ext.Ajax.request({
                url: '/intranet-budget/reclassify', 
                params: { 'project_id': @main_project_id@ },
                success: function(response){
                    budgetItemTreeStore.load();		// Reload the store to get the updated values

                    // Re-load the store after a second
                    // ToDo: Check if reclassification was finished
                    // setTimeout(function() {   }, 1000);
                },
                failure: function(response){
                    PO.Utilities.reportError('Error reclassifying cost items', response.responseText);
                }
            });
        }

    });

    // Enable only the columns showing the "actuals"
    budgetTreePanel.switchColumns('actuals');


    /**
     * Button and tree action controller:
     * Deal with collapsible tree nodes, keyboard commands
     * and the interaction with the GanttBarPanel.
     */
    Ext.define('BudgetEditor.controller.BudgetTreePanelController', {
        extend: 'Ext.app.Controller',
        requires: ['Ext.app.Controller'],
        refs: [
            {ref: 'budgetBarPanel', selector: '#budgetBarPanel'},
            {ref: 'budgetTreePanel', selector: '#budgetTreePanel'}
        ],

        budgetTreePanel:		budgetTreePanel,
        senchaPreferenceStore:		senchaPreferenceStore,
        resizeController:		null,

        init: function() {
            var me = this;
            this.control({
                '#budgetTreePanel': {
                    'itemcollapse': this.onItemCollapse,
                    'itemexpand': this.onItemExpand
                },
                '#buttonMaximizeBudget': { click: this.onButtonMaximize },
                '#buttonMinimizeBudget': { click: this.onButtonMinimize },
                '#buttonAddBudget': { click: this.onButtonAdd },
                '#buttonDeleteBudget': { click: this.onButtonDelete }

            });

            if (null != me.budgetTreePanel) {
                var budgetTreeView = me.budgetTreePanel.getView();
                budgetTreeView.on({
                    'drop': me.onBudgetTreePanelDrop,
                    'scope': this
                });;
            }
        },

        /**
         * The user has collapsed a super-task in the BudgetTreePanel.
         * We now save the 'c'=closed status using a ]po[ URL.
         * These values will appear in the TaskTreeStore.
         */
        onItemCollapse: function(taskModel) {
            var me = this;
            var object_id = taskModel.get('id');
            if (me.debug) console.log('BudgetTreePanelController.onItemCollapse: '+object_id);
            Ext.Ajax.request({
                url: '/intranet/biz-object-tree-open-close.tcl',
                params: { 'object_id': object_id, 'open_p': 'c' }
            });
        },

        /**
         * The user has expanded a super-task in the BudgetTreePanel.
         * Please see onItemCollapse for further documentation.
         */
        onItemExpand: function(taskModel) {
            var me = this;
            var object_id = taskModel.get('id');
            if (me.debug) console.log('PO.class.BudgetDrawComponent.onItemExpand: '+object_id);
            Ext.Ajax.request({
                url: '/intranet/biz-object-tree-open-close.tcl',
                params: { 'object_id': object_id, 'open_p': 'o' }
            });
        },

        /**
         * The user pressed the "Maximize" button.
         */
        onButtonMaximize: function() {
            var me = this;
            if (me.debug) console.log('PO.class.BudgetDrawComponent.onButtonMaximize: Started');

            var buttonMaximize = Ext.getCmp('buttonMaximizeBudget');
            var buttonMinimize = Ext.getCmp('buttonMinimizeBudget');
            buttonMaximize.setVisible(false);
            buttonMinimize.setVisible(true);
            me.resizeController.onSwitchToFullScreen();
            
            if (me.debug) console.log('PO.class.BudgetDrawComponent.onButtonMaximize: Finished');
        },
        
        /**
         * The user pressed the "Maximize" button.
         */
        onButtonMinimize: function() {
            var me = this;
            if (me.debug) console.log('PO.class.BudgetDrawComponent.onButtonMinimize: Started');

            var buttonMaximize = Ext.getCmp('buttonMaximizeBudget');
            var buttonMinimize = Ext.getCmp('buttonMinimizeBudget');
            buttonMaximize.setVisible(true);
            buttonMinimize.setVisible(false);
            me.resizeController.onSwitchBackFromFullScreen();
            
            if (me.debug) console.log('PO.class.BudgetDrawComponent.onButtonMinimize: Finished');
        },

        /**
         * "Add" (+) button pressed.
         * Insert a new task in the position of the last selection.
         */
        onButtonAdd: function() {
            var me = this;
            if (me.debug) console.log('PO.view.budget.BudgetTreePanelController.onButtonAdd: ');

            var budgetTreePanel = me.getBudgetTreePanel();
            var cellEditing = budgetTreePanel.plugins[0];
            var budgetTreeStore = budgetTreePanel.getStore();
            var root = budgetTreeStore.getRootNode();				// The root of the budget tree is "root"
            var topBudgetItem = root.firstChild;
            if (!topBudgetItem) { PO.Utilities.reportMessage('Error creating budget item', "Tree has no top budget item."); return; }

            cellEditing.cancelEdit();
            var selectionModel = budgetTreePanel.getSelectionModel();
            var lastSelected = selectionModel.getLastSelected();

            // We have to have some tree node on which to add the new budget item...
            if (!lastSelected) {
                lastSelected = topBudgetItem;					// This should be the main project
            }

            // We can't create a budget item below a cost item...
            var object_type = lastSelected.get('object_type');			// im_budget_item
            var budget_item_id = lastSelected.get('id');        		// im_budget_item
            if (!budget_item_id || !object_type || object_type !== "im_budget_item") {
                PO.Utilities.reportMessage('Error creating budget item',
                        "You can not create a new BI below a cost item.<br>" +
                        "A new budget item needs to be below another budget item."
                );
                return;
            }

            // Get a server-side object_id for the task
            Ext.Ajax.request({
                url: '/intranet-rest/data-source/next-object-id',
                success: function(response){
                    var json = Ext.JSON.decode(response.responseText);
                    var object_id_string = json.data.object_id;
                    var object_id = parseInt(object_id_string);

                    // Create a new BudgetItem
                    var r = Ext.create('PO.budget.BudgetTreeItem', {
                        id: ''+object_id,
                        budget_item_id: ''+object_id,
                        budget_item_name: 'New Budget Item (#'+object_id+')',
                        name: 'New Budget Item (#'+object_id+')',
                        nr: 'bi_'+object_id,
                        budget_item_nr: 'bi_'+object_id,
                        budget_item_parent_id: ""+budget_item_id,
                        budget_item_project_id: ""+@main_project_id@,
                        budget_item_status_id: "49000",							// Status: 
                        object_status_id: "49000",
                        budget_item_type_id: "49100",							// Type:
                        object_type_id: "49100",
                        sort_order: "0",
                        iconCls: 'icon-budget-item',
                        object_type: "im_budget_item",
                        leaf: true
                    });

                    var rNode = root.createNode(r);							// Convert model into tree node
                    rNode.set('leaf', true);    							// The new task is a leaf (show different icon)

                    // insert the node into the tree:
                    // ... after the last item of that level
                    // var index = lastSelectedParent.indexOf(lastSelected);        		// Get the index of the last selected
                    var index = lastSelected.indexOf(lastSelected.lastChild);			// Get the index of the last selected
                    // lastSelected.insertChild(index+1,rNode);
                    lastSelected.appendChild(rNode);

                    // For first task in project: Update the root
                    var lastSelectedParent = lastSelected.parentNode;
                    lastSelected.set('leaf', false);						// Parent is not a leaf anymore
                    lastSelected.expand();							// Expand parent if not yet expanded
                    selectionModel.select(rNode);
                    cellEditing.startEdit(rNode, 1);
                    
/*                    // select/Highlight the name of the newly created task in order to speedup entering new tasks manually
                    var columnHeader = cellEditing.context.column;
                    var ed = rowEditing.getEditor(rNode, columnHeader);
                    var inputEl = ed.field.inputEl;
                    inputEl.dom.select();
*/
                    budgetItemTreeStore.sync({
                        failure: function(batch, options) {
                            var message = batch.proxy.reader.jsonData.message;
                            PO.Utilities.reportError('Error adding budget item', message);
                        }
                    });

                },
                failure: function(response){
                    PO.Utilities.reportError('Error retreiving object_id from server',
                                  'This error may lead to data-loss for your project. Error: '+response.responseText);
                }
            });

            // select/Highlight the name of the newly created task in order to speedup entering new tasks manually
/*
            var columnHeader = cellEditing.context.column;
            var ed = cellEditing.getEditor(rNode, columnHeader);
            var inputEl = ed.field.inputEl;
            inputEl.dom.select();
*/
        },

        /**
         * "Delete" (-) button pressed.
         * Delete the currently selected task from the tree.
         */
        onButtonDelete: function() {
            var me = this;
            if (me.debug) console.log('PO.view.budget.BudgetTreePanelController.onButtonDelete: ');


            var budgetTreePanel = me.getBudgetTreePanel();
            var cellEditing = budgetTreePanel.plugins[0];
            var budgetTreeStore = budgetTreePanel.getStore();
            var root = budgetItemTreeStore.getRootNode();
            var selectionModel = budgetTreePanel.getSelectionModel();
            var lastSelected = selectionModel.getLastSelected();
            var lastSelectedParent = lastSelected.parentNode;
            var lastSelectedIndex = lastSelectedParent.indexOf(lastSelected);
            var lastSelectedId = lastSelected.get('id');


            // ----------------------------------------------------------
            // Check for dependencies before delete

            var children = lastSelected.childNodes;
            if (children.length > 0) {
                PO.Utilities.reportMessage('Error deleting budget item', "This budget item has child elements. Please move or delete the children first.");
                return;
            }
            var object_type = lastSelected.get('object_type');
            if ("im_budget_item" !== object_type) {
                PO.Utilities.reportMessage('Error deleting item', "You can not delete cost items.<br>You can only delete budget items.");
                return;
            }

            // ----------------------------------------------------------
            // Work with selection in the task tree

            cellEditing.cancelEdit();							// Just in case the editor was active...
            lastSelected.remove();								// Remove the selected element

            budgetItemTreeStore.sync({
                success: function(batch, options) { },
                failure: function(batch, options) {
                    var message = batch.proxy.reader.jsonData.message;
                    PO.Utilities.reportError('Error deleting budget item', message);
                }
            });

            var numChildren = lastSelectedParent.childNodes.length;				// Check if we deleted the last task of a parent.
            if (0 == numChildren) {								// This parent then becomes a normal task again.
                lastSelectedParent.set('leaf', true);					// Parent is not a leaf anymore
            }

            // Select the next node
            var newNode = lastSelectedParent.getChildAt(lastSelectedIndex);
            if (typeof(newNode) == "undefined") {
                lastSelectedIndex = lastSelectedIndex -1;
                if (lastSelectedIndex < 0) { lastSelectedIndex = 0; }
                newNode = lastSelectedParent.getChildAt(lastSelectedIndex);
            }

            // lastSelected was the last child of it's parent, so select the parent.
            if (typeof(newNode) == "undefined") {
                selectionModel.select(lastSelectedParent);
            } else {
                newNode = lastSelectedParent.getChildAt(lastSelectedIndex);
                selectionModel.select(newNode);
            }

            budgetItemTreeStore.sync({
                success: function(batch, options) { },
                failure: function(batch, options) {
                    var message = batch.proxy.reader.jsonData.message;
                    PO.Utilities.reportError('Error reclassifying cost items', message);
                }
            });

        },

        /**
         * The user has clicked below the last task.
         * We will interpret this as the request to create a new task at the end.
         */
        onContainerClick: function() {
            var me = this;
            if (me.debug) console.log('PO.view.budget.BudgetTreePanelController.onContainerClick: ');

            alert('BudgetTreePanelController.onContainerClick');

            // Clear the selection in order to force adding the task at the bottom
            var budgetTreePanel = me.getBudgetTreePanel();
            var selectionModel = budgetTreePanel.getSelectionModel();
            selectionModel.deselectAll();

            me.onButtonAdd();
        },

        /**
         * Drop events inside the task tree.
         * We need to update the budget_item_parent_id and sort_order of the task.
         */
        onBudgetTreePanelDrop: function(node, data, overModel, dropPosition, eOpts) {
            var me = this;
            if (me.debug) console.log('PO.controller.BudgetTreePanelController.onBudgetTreePanelDrop: Starting');

            var records = data.records; 							// tasks dropped into new position
            var parent = null;

            // Update the budget_item_parent_id of the task
            switch (dropPosition) {
            case "before":
                // parent = overModel.parentNode;
                parent = overModel;
                break;
            case "after":
                // parent = overModel.parentNode;
                parent = overModel;
                break;
            case "append":
                parent = overModel;
                break;
            default:
                alert("BudgetTreePanelController.onBudgetTreePanelDrop: Unknown dropPosition="+dropPosition);
                break;
            }
            var budget_item_parent_id = parent.get('id');
            if (null == budget_item_parent_id || "" == budget_item_parent_id) {
                if (me.debug) console.log('PO.controller.BudgetTreePanelController.onBudgetTreePanelDrop: Empty ID of parent');
                return false;
            }

            records.forEach(function(record) {
                record.set('budget_item_parent_id', budget_item_parent_id);
            });

            budgetItemTreeStore.sync({
                success: function(batch, options) { },
                failure: function(batch, options) {
                    var message = batch.proxy.reader.jsonData.message;
                    PO.Utilities.reportError('Error after drop action: ', message);
                }
            });

            if (me.debug) console.log('PO.controller.BudgetTreePanelController.onBudgetTreePanelDrop: Finished');
        }
    });  // End of BudgetTreePanelController


    // Controller to handle size and resizing related events
    var renderDiv = Ext.get("@budget_tree_id@");
    var resizeController = Ext.create('PO.controller.ResizeController', {
        debug: getDebug('resizeController'),
        redrawPanel: budgetTreePanel,						// panel with redraw() function and needsRedraw variable
        renderDiv: renderDiv,							// container of outerContainer
        outerContainer: budgetTreePanel					// outermost panel with resize border
    }).init();
    resizeController.onLaunch(this);
    resizeController.onResize();						// Set the size of the outer GanttButton Panel

    
    // Controller to handle functional budget buttons
    var budgetTreePanelController = Ext.create('BudgetEditor.controller.BudgetTreePanelController', {
        budgetTreePanel: budgetTreePanel,
        senchaPreferenceStore: senchaPreferenceStore,
        debug: true  // getDebug('budgetTreePanelController')
    });
    budgetTreePanelController.resizeController = resizeController;
    budgetTreePanelController.init(this);

    /*
    // Member panel for member field - but don't show it yet.
    var objectMemberPanel = Ext.create('PO.view.ObjectMemberPanel', {
        debug: getDebug('objectMemberPanel'),
        senchaPreferenceStore: senchaPreferenceStore,
        userStore: userStore
    });
    objectMemberPanel.hide();
    */
};


// Handle debugging from parameters
var debugHash = @debug_json;noquote@;
function getDebug(id) {
    var debug = parseInt(debugHash[id]);	// Check for a debug setting for the specific Id
    if (!isNaN(debug)) return debug;
    debug = parseInt(debugHash['default']);	// Use the default debug
    if (!isNaN(debug)) return debug;
    return 1;					// invalid configuration - enable debug
};


// Load the required stores first and then start the application
// via launchBudgetTreePanel().
Ext.onReady(function() {
    Ext.QuickTips.init();
    var debug = getDebug('default');

    var budgetItemStatusStore = Ext.create('PO.store.finance.BudgetItemStatusStore');
    var budgetItemTypeStore = Ext.create('PO.store.finance.BudgetItemTypeStore');
    var costStatusStore = Ext.create('PO.store.finance.CostStatusStore');
    var costTypeStore = Ext.create('PO.store.finance.CostTypeStore', {storeId: 'costTypeStore'});
    var classifiedCostTypeStore = Ext.create('PO.store.finance.CostTypeStore',  {storeId: 'classifiedCostTypeStore'});      // copy with selected elements
    var expenseItemTypeStore = Ext.create('PO.store.finance.ExpenseItemTypeStore');
    var materialTypeStore = Ext.create('PO.store.finance.MaterialTypeStore');
    var budgetItemTreeStore = Ext.create('PO.budget.BudgetTreeItemStore');
    var budgetGroupStore = Ext.create('PO.store.group.GroupStore', {storeId: 'budgetGroupStore'});
    var budgetManagerStore = Ext.create('PO.store.user.UserStore', {storeId: 'budgetManagerStore'});
    
    var senchaPreferenceStore = Ext.StoreManager.get('senchaPreferenceStore');
    if (!senchaPreferenceStore) {
        senchaPreferenceStore = Ext.create('PO.store.user.SenchaPreferenceStore');
    } else {
        senchaPreferenceStore.loaded = true;
    }
    
    var categoryStore = Ext.create('PO.store.CategoryStore');
    var taskTreeStore = Ext.create('PO.store.timesheet.TaskTreeStore');
    var userStore = Ext.create('PO.store.user.UserStore', {storeId: 'userStore', remoteFilter: false});

    // Use "store coodinator" to launchBudgetTreeTreePanel() after all stores are loaded:
    var budgetCoordinator = Ext.create('PO.controller.StoreLoadCoordinator', {
        debug: false,
        stores: [
            'taskTreeStore',
            'budgetItemStatusStore', 
            'budgetItemTypeStore', 
            'budgetManagerStore',
            'budgetTreeItemStore',
            'costStatusStore', 
            'costTypeStore',
            'budgetGroupStore',
            'expenseItemTypeStore',
            'materialTypeStore',
            'senchaPreferenceStore',
            'categoryStore',
            'userStore'
        ],
        listeners: {
            load: function() {
                if (this.finished) return;
                this.finished = true;
                launchBudgetTreePanel();                // Launch the actual application.
            }
        }
    });

    // Load stores that need parameters
    taskTreeStore.getProxy().extraParams = { project_id: @main_project_id@ };
    taskTreeStore.load({
        callback: function(records, operation, success) {
            var me = this;
            if (debug) console.log('PO.store.timesheet.TaskTreeStore: loaded');

            if (!success) {
                PO.Utilities.reportStoreError("TaskTreeStore", operation);
                return;
            }

            var mainProjectNode = records[0];
            mainProjectNode.set('sort_order','0');
            me.setRootNode(mainProjectNode);
        }
    });

    // User store - load last, because this can take some while. Load project members
    userStore.getProxy().extraParams = { 
        format: 'json',
        query: "user_id in (select object_id_two from acs_rels where object_id_one = @main_project_id@)"
    };
    userStore.load({callback: function(r, op, success) { if (!success) PO.Utilities.reportStoreError("UserStore", op); }});

    // Load stores that need parameters
    budgetItemStatusStore.load({callback: function(r, op, success) { if (!success) PO.Utilities.reportStoreError("BudgetItemStatusStore", op); }});
    budgetItemTypeStore.load({callback: function(r, op, success) { if (!success) PO.Utilities.reportStoreError("BudgetItemTypeStore", op); }});
    budgetGroupStore.load({callback: function(r, op, success) { if (!success) PO.Utilities.reportStoreError("BudgetGroupStore", op); }});
    costStatusStore.load({callback: function(r, op, success) { if (!success) PO.Utilities.reportStoreError("CostStatusStore", op); }});
    costTypeStore.load({callback: function(r, op, success) {
        if (!success) {
            PO.Utilities.reportStoreError("CostTypeStore", op);
        } else {
            // Create a copy of selected elements from costTypeStore
            var badCostTypes = [3700, 3704, 3708, 3710, 3714, 3716, 3720, 3726, 3728, 3730, 3732, 3734, 3736];
            var goodCostTypes = [3718, 3704, 3722];
            costTypeStore.each(function(costTypeModel) {
                var id = parseInt(costTypeModel.get('category_id'));
                if (goodCostTypes.includes(id)) {
                    classifiedCostTypeStore.add(costTypeModel);
                }
            });
        }
    }});
    expenseItemTypeStore.load({callback: function(r, op, success) { if (!success) PO.Utilities.reportStoreError("ExpenseItemTypeStore", op); }});
    materialTypeStore.load({callback: function(r, op, success) { 
        var model = Ext.create('PO.model.category.Category', {
            id: "0", category_id: "", category: '', category_type: 'Intranet Material Type', category_translated: ''
        });
        materialTypeStore.insert(0, model);
        if (!success) PO.Utilities.reportStoreError("MaterialTypeStore", op); 
    }});
    budgetItemTreeStore.getProxy().extraParams = { project_id: @project_id@ };
    budgetItemTreeStore.load({callback: function(r, op, success) { 
        if (!success) PO.Utilities.reportStoreError("BudgetItemTreeStore", op);
        // budgetItemTreeStore.filterBy(function(a,b) { return true; });
    }});
    categoryStore.load({callback: function(r, op, success) {
        console.log('Ext.onReady: categoryStore.load: '+success);
        if (!success) PO.Utilities.reportStoreError("CategoryStore", op);
    }});

    // This is a conventional UserStore with an extra parameter
    // to limit the users to Senior Managers or members of the project.
    budgetManagerStore.getProxy().extraParams = { 
        format: 'json',
        query: "user_id in (					\
                select  member_id                               \
                from    group_distinct_member_map               \
                where   group_id = @senior_manager_group_id@    \
        )"
    };
    budgetManagerStore.load({callback: function(r, op, success) { if (!success) PO.Utilities.reportStoreError("BudgetMemberStore", op); }});

    
    // User preferences
    if (!senchaPreferenceStore.loaded)
        senchaPreferenceStore.load({callback: function(r, op, success) { if (!success) PO.Utilities.reportStoreError("UserPreferenceStore", op); }});

});
</script>
</div>

<if "" ne @data_list@>
</if>
